<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class LoadObservationController {
  private $util;

  public function __construct(Util $util) {
    $this->util = $util;
  }

  public function getObservation(Request $request, Response $response) {
    try {
      $data = $request->getParameters();
      
      $conditionsArray = [
        "CDFILIAL"      => $data["CDFILIAL"],
        "NRCOLEPRECO"   => $data["NRCOLEPRECO"],
        "CDREGIAO"      => $data["CDREGIAO"],
        "CDFORNECED"    => $data["CDFORNECED"],
        "CDPRODUTO"     => $data["CDPRODUTO"],
        "CDMARCA"       => $data["CDMARCA"],
        "NRORG"         => $data["NRORG"]
      ];
      $observation = $this->util->filteredDataSet($conditionsArray, "getObservation")[0];

      return $response->addDataSet(new DataSet("observation", $observation));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao pegar observação: " . $exception->getMessage(), 500);
    }
  }
}