<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Controllers\QR2StrategySAAS;
use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Controller\Report;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;

use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class RemoteReportController extends Report
{
    private $entityManager;
    private $environment;
    private $newCode;
    private $connection;
    protected $reportService;
    private $qr2Strategy;
    private $birtStrategy;
    private $util;

    public function __construct(
        EntityManager $entityManager,
        Environment $environment,
        NewCode $newCode,
        Connection $connection,
        ReportService $reportService,
        QR2StrategySAAS $qr2Strategy,
        BirtStrategy $birtStrategy,
        Util $util
    ) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->newCode       = $newCode;
        $this->connection    = $connection;
        $this->reportService = $reportService;
        $this->qr2Strategy   = $qr2Strategy;
        $this->birtStrategy  = $birtStrategy;
        $this->util          = $util;
    }

    public function beforeProcessReport(Request $request, Response $response)
    {
        $data = $request->getRow();

        $this->qr2Strategy->setQr2Type($data["TYPE"]);
        $this->birtStrategy->setReportFormat($data["TYPE"]);
        $this->stNomeRel = $this->getReportName($data);

        if ($data["OPERADOR"] != "T") {
            $nrlistaForn = $this->util->createListValues($data["OPERADOR"]);
            $data["OPERADOR"] = "_NRLISTA=" . $nrlistaForn;
        }

        $this->reportMapping[$this->stNomeRel] =
            [
                "strategy"         => "BIRT",
                "parameterMapping" => [
                    "OPERADOR"   => "L_CDOPERADOR",
                    "P_DATAINIC" => "P_DATAINIC",
                    "P_DATAFINA" => "P_DATAFINA",
                    "DTINI"      => "P_DTI",
                    "DTFIM"      => "P_DTF",
                    "NR_COTACAO" => "P_NRCOLEPRLOG",
                    "NRORG"      => "P_NRORG"
                ]
            ];
    }
}
