<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Services\QuoteSheetGrid\SaveObservationService as Service;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class SaveObservationController {
  private $service;

  public function __construct(Service $service) {
    $this->service = $service;
  }

  public function saveObservation(Request $request, Response $response) {
    try {
      $data = $request->getParameters()["params"];

      $this->service->salvarObservacao($data);

      return $response->addDataSet(new DataSet("saveObservation", ["message" => "Inclusão de observação realizada com sucesso.", "status_code" => 200]));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao salvar observação: " . $exception->getMessage(), 500);
    }
  }
}
