<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Services\QuoteSheetGrid\UpdatePaymentMethodService as Service;
use SupNext\Services\QuoteSheetGrid\SaveAdditionalDataService as AdditionalData;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class UpdatePaymentMethodController {
    private $service;
    private $additionalData;

    public function __construct(Service $service, AdditionalData $additionalData) {
        $this->service        = $service;
        $this->additionalData = $additionalData;
    }

    public function updatePaymentMethod(Request $request, Response $response) {
        try {
            $data = $request->getParameters()["params"];

            $this->additionalData->updateItemCole($data[1]);
            $this->additionalData->deletePaymentDeadline($data[1]);
            
            if ($data[1]["IDTPFOPGTCOL"] == "V") {
                foreach ($data[0] as $row) {
                    $data[1]["NRDIAPGFXCOL"] = $row["NRDIAPGFXCOL"];
                    $data[1]["NRPARCPGTCOL"] = $row["NRPARCPGTCOL"];

                    $this->service->insertPlot($data[1]);
                }
            }

            return $response->addDataSet(new DataSet("updatePaymentMethod", ["message" => "Atualização da forma de pagamento realizada com sucesso.", "status_code" => 200]));
        } catch (\Exception $exception) {
            throw new \Exception("Erro ao atualizar forma de pagamento: " . $exception->getMessage(), 500);
        }
    }
}
