<?php

namespace SupNext\Services\QuoteSheetGrid;

use SupNext\Util\Util;

class DeleteSupplierService {
  private $util;

  public function __construct(Util $util) {
    $this->util       = $util;
  }

  public function deleteSupplier(array $data): void {
    try {
      $query = "DELETE FROM ITEMCOLE
                WHERE CDFILIAL = :P_CDFILIAL
                      AND NRCOLEPRECO = :P_NRCOLEPRECO
                      AND CDREGIAO = :P_CDREGIAO
                      AND CDFORNECED = NVL(:P_CDFORNECED, CDFORNECED)
                      AND NRORG = :P_NRORG";

      $params = [
        "P_CDFILIAL"    => $data["CDFILIAL"],
        "P_NRCOLEPRECO" => $data["NRCOLEPRECO"],
        "P_CDREGIAO"    => $data["CDREGIAO"],
        "P_CDFORNECED"  => $data["CDFORNECED"] ?? null,
        'P_NRORG'       => $data["NRORG"]
      ];

      $this->util->crud($query, $params);
    } catch (Exception $exception) {
      throw new \Exception("Erro ao executar query para deletar região: " . $exception->getMessage(), 500);
    }
  }
}