<?php

namespace SupNext\Services\QuoteSheetGrid;

use Doctrine\DBAL\Connection;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class LoadBestPricesService {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function excuteprocMelhorPrecoAuto(array $data): void {
        try {
            $procedure = new StoredProcedure($this->connection, 'MELHOR_PRECO_AUTO');

            $procedure->addParam(new Param("P_CDFILIAL",    Param::PARAM_INPUT,  $data["CDFILIAL"],         Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRCOLEPRECO", Param::PARAM_INPUT,  $data["NRCOLEPRECO"],      Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTINI",       Param::PARAM_INPUT,  $data["FORM_DTINIVALCOL"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTFIN",       Param::PARAM_INPUT,  $data["FORM_DTFINVALCOL"], Param::PARAM_TYPE_STR));

            $procedure->execute();
        } catch (Exception $exception) {
            throw new \Exception("Erro ao executar query deleção itens com preço zerado: " . $exception->getMessage(), 500);
        }
    }
}