export interface IFilterData {
  buyer: Array<string> | string;
  region: Array<string> | string;
  supplier: Array<string> | string;
  validity: Array<string> | string;
}

export interface ISupplierFilter {
  P_NRORG: string;
  P_IDULTIDTVALQ: string;
  P_DTCOL: string;
}

export interface IFormQuotationInclusion {
  CDOPERADOR: string;
  DTCOLEPREC: string;
  CDREGIAO: Array<string>;
  CDFORNECED: Array<string>;
  CDMARCA: Array<string>;
  DTINIVALCOL: string;
  DTFINVALCOL: string;
  NRSEMAINIC: number;
  NRSEMAFINAL: number;
  IDTIPOCOTACAO: string;
  CDPRODINI: string;
  CDPRODFIN: string;
  CDVERIF: string;
  IDCARGOBS: string;
  IDCARGULTC: string;
  IDDISMONTLIS: string;
  NRCOMPRA: string;
  DSOBSCOTPREC: string;
  CDOPERINCL: string;
}

export interface IFilterQuoteSupplier {
  P_CDFILIAL: string;
  P_NRCOLEPRECO: string;
  P_NRORG: string;
}

export interface IFilterLoadRegionPrices extends IFilterQuoteSupplier {}

export interface IAddRegionParams {
  CDREGIAO: string;
  IDULTIDTVALQ: string;
  CDREGIAOPREC: string | null;
  NRINSJURFORN: string | null;
  NMFANTFORN: string | null;
  CDFORNECED: string | null;
  NRCOLEPRECO: string;
  DTCOLEPREC: string;
  IDUTINDICECOL: string;
  CDOPERINCL: string;
  CDFILIPROC: string;
  CDFILIAL: string;
  NRORG: string;
}

export interface IAddProductsParams {
  CDFILIAL: string;
  CDFILIPROC: string;
  CDFORNECED: string;
  CDMARCA: string;
  CDOPERINCL: string;
  CDPRODUTO: string;
  CDREGIAO: string;
  DTCOLEPREC: string;
  IDATUFORN: boolean;
  IDATUREG: boolean;
  IDUTINDICECOL: string;
  NMMARCA: string;
  NMPRODUTO: string;
  NRCOLEPRECO: string;
  VRPRECUNIITM: number;
  CDTPINDICECOL?: string;
  IDPERVALORCOL?: string;
  CDINDICECOL?: string;
  DTREFINDCOL?: string;
}

export interface IFilterInconsistencies {
  P_CDFILIAL: string;
  P_LISTACOTACAO: string;
  P_NRCOLEORILIC: string;
}

export interface IReplicateQuotationParams {
  CONSCOTAN: string;
  CDFILIAL: string | null;
  CDFILIPROC: string | null;
  CDOPERINCL: string | null;
  NRCOLEPRECO: string;
  IDDUPLICA: string;
  DTINIVALCOL: string | Date;
  DTFINVALCOL: string | Date;
  DTNOVINIVAL: string | Date;
  DTNOVFINVAL: string | Date;
  NRSEMAINIC: number | null;
  NRSEMAFINAL: number | null;
  DTCOLEPREC: string | null;
  REAJUSTE: number;
  CDOPERADOR: string | null;
  TCDOPERADOR: string | null;
  CDREGIAO: string | null;
  CDREGIAOOL: string | null;
  DUPLICAOL: string;
  NRORG: string;
}

export interface ICreateRemoteReport {
  DTINI: string;
  DTFIM: string;
  P_DATAINIC: string;
  P_DATAFINA: string;
  NR_COTACAO: string | null;
  OPERADOR: string;
  TYPE: string;
  NRORG: string;
  REPORT_NAME: string;
  __report_name: string;
  STRATEGY: string;
  isUrl: boolean;
}
