import { AppState } from '@/controllers/AppState';
import { Utilities } from '@/util/Utilities';

export class AppStateController {
  private appState: AppState;

  private utilities: Utilities;

  constructor() {
    this.appState = AppState.getInstance();
    this.utilities = new Utilities();
    this.initializeAppState();
  }

  private async initializeAppState(): Promise<void> {
    await this.appState.initialize(this.utilities);
  }

  public getAppState() {
    return this.appState;
  }
}
