module.exports = {
	publicPath: process.env.VUE_APP_PUBLIC_PATH,
	devServer: {
		public: "http://192.168.122.53:10588/",
		port: process.env.VUE_APP_DEV_SERVER_PORT
	},
	assetsDir: './assets',
	chainWebpack: (config) => {
		config.resolve.symlinks(false);
	},
	runtimeCompiler: true,
	configureWebpack: {
		module: {
			rules: [{
				test: /\.js$/,
				loader: 'babel-loader',
				exclude: /node_modules/,
				options: {
					plugins: [
						['@babel/plugin-proposal-decorators', { legacy: true }],
						'@babel/plugin-proposal-class-properties',
					]
				}
			}, ]
		},
		optimization: {
			splitChunks: {
				chunks: 'all',
				maxInitialRequests: Infinity,
				minSize: 0,
				cacheGroups: {
					vendor: {
						test: /[\\/]node_modules[\\/]/,
						name(module) {
							let packageName = module.context.match(/[\\/]node_modules[\\/](.*?)([\\/]|$)/);
							if (packageName[1] === '@zeedhi') {
								packageName = module.context.match(/[\\/]node_modules[\\/](.*?)[\\/](.*?)([\\/]|$)/);
								return `npm.${packageName[1].replace('@', '')}.${packageName[2]}`;
							}
							else {
								return `npm.${packageName[1].replace('@', '')}`;
							}
						}
					},
					styles: {
						test: /\.css$/,
						name: 'styles',
						chunks: 'all',
						enforce: true
					}
				}
			}
		}
	}
}
